#include <string.h>
#include <stdlib.h>

struct Benutzer
{
  char benutzername[16];
  char eMailAdresse[16]; //z.B. a.mueller@abc.de
};
typedef struct Benutzer Benutzer;

// 8. Schreiben Sie eine C-Funktion:
// char* findeDoppelteEMailAdresse(Benutzer b[], int anzahl)
// Diese soll die bergebenen Benutzerdaten danach durchsuchen,
// ob eine E-Mail-Adresse doppelt vorkommt,
// und dann einen der davon betroffenen Benutzernamen zurckgeben
// -- oder NULL, falls keine E-Mail-Adresse doppelt vorkommt.
// Sie knnen strcmp aus string.h verwenden.

char* findeDoppelteEMailAdresse(Benutzer b[], int anzahl)
{
  for(int i = 0; i < anzahl; i++)
  {
    for(int j = i + 1; j < anzahl; j++)
    {
      if(strcmp(b[i].eMailAdresse, b[j].eMailAdresse) == 0)
      {
        return b[i].benutzername;
      }
    }
  }
  return NULL;
}

Benutzer* findeAlleDoppeltenEMailAdressen(Benutzer b[], int anzahl, int *pEchteFaelle)
{
  int zahlFaelle = 0;
  for(int i = 0; i < anzahl; i++)
  {
    for(int j = i + 1; j < anzahl; j++)
    {
      if(strcmp(b[i].eMailAdresse, b[j].eMailAdresse) == 0)
      {
        zahlFaelle++;
      }
    }
  }
  
  Benutzer *faelle = malloc(2 * zahlFaelle * sizeof (Benutzer) );
  if(faelle == NULL)
  {
    // Speicherreservierung fehlgeschlagen
  }
  
  Benutzer *z = faelle;
  int echteFaelle = 0;
  
  for(int i = 0; i < anzahl; i++)
  {
    for(int j = i + 1; j < anzahl; j++)
    {
      if(strcmp(b[i].eMailAdresse, b[j].eMailAdresse) == 0)
      {
        *z = b[i];
        z++;
        echteFaelle++;
        *z = b[j];
        z++;
        echteFaelle++;
      }
    }
  } 
  
  *pEchteFaelle = echteFaelle;
  
  return faelle;
}

Benutzer benutzer[] = {{"Anton","anto3@67.qerqer"},
                       {"Berta","anton@wgw.qer"},
                       {"Carla","antonf@ghs.qer"},
                       {"Doris","anton@wgw.qer"},
                       {"Egon","anton@5wgw.qer"},
                      };

int main( void )
{
  int zahl;
  Benutzer *ben = findeAlleDoppeltenEMailAdressen(benutzer, 5, &zahl);

  free(ben);
  
  
  {
    // Welche Werte stehen nach Ausfhrung dieser Zeilen C-Code
    // in den Variablen a, b, c?
    int u[3] = {5, 6};
    int v = 100;
    int *w = &v; // w zeigt auf v
    int *x = u; // x zeigt auf u[0]
    x++; // x zeigt auf u[1]
    *w = 7; // v auf 7 setzen
    int a = v; // 7
    int b = u[2]; // 0
    int c = x[0]; // 6
    int d = x[-1]; // 5
    int e = *x; // 6
    int f = *(x-1); // 5
    int g = 0[x]; // *(0+x), also 6
  }
  int dummy;
  {
    // Welche Werte stehen nach Ausfhrung dieser Zeilen C-Code
    //  in den Variablen x, y, z?
      int a = 42;
      int b[4] = {13, 7, 11};
      int *c = &a; // c zeigt auf a.
      int *d = &b[1]; // d zeigt auf b[1].
      d++; // d zeigt auf b[2]
      (*d)++; // erhhe b[2]
      *c = 9; // a = 9
      int x = a; // 9
      int y = b[2]; // 12
      int z = b[3]; // 0
      dummy = z;
  }

  return 0;
}
